<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.menu');

class plgBill_gatewaysPaycheque extends JPlugin
{

	var $_db = null;
	function plgBill_gatewaysPaycheque(& $subject, $config)
	{
		$this->_db = JFactory :: getDBO();
		parent :: __construct($subject, $config);
	}
	function onReceivePayment( &$post )
	{
		global $mainframe;

		if( $mainframe->isAdmin() ) return;
		if( $post['processor'] != 'paycheque' ) return 0;

		$user   = & JFactory::getUser();
		$config = & JFactory::getConfig();

		$invoice = JTable::getInstance( 'invoice', 'Table' );
		$invoice->load( $post['order_id'] );

		$post['params'] = $invoice->params;

		$params = new JParameter( $post['params'] );

		$default = $this->params;

		$out['sid']        = $post['order_id'];
		$out['gateway']    = $post['gateway'];
		$out['gateway_id'] = $post['gateway_id'];
		$out['user_id']    = $post['user_id'] ? $post['user_id'] : $user->get('id');
		$out['price']      = $post['order_amount'];
		$out['pay']        = $post['order_amount'] > 0 ? 'offline' : 'success';
		$out['email']      = $post['email'];

		if($params->get('paycheque_published', $default->get('paycheque_published', 0)))
		$out['pay'] = 'success';

		if( class_exists( 'Bill' ) ) {
			$out['key']  = strtoupper( md5( Bill::getSecretWord().$out['user_id'].$post['gateway_id'].$out['price'].$out['sid'] ) );
		}


		jimport( 'joomla.mail.mail' );
		jimport( 'joomla.mail.helper' );

		$mailfrom = $config->getValue( 'config.mailfrom' );
		$fromname = $config->getValue( 'config.fromname' );


		if(!$params->get('paycheque_published', $default->get('paycheque_published', 0)) || ($params->get('paycheque_published', $default->get('paycheque_published', 0)) && $params->get('paycheque_pubemail', $default->get('paycheque_pubemail', 0))))
		{
			$body = $params->get( 'paycheque_cus_body', $default->get( 'paycheque_cus_body' ) );

			$invoice_url = JURI::root().'index.php?option=com_jsbill&task=invoice&id='.$post['order_id'].( ( isset( $post['itemId'] ) && $post['itemId']  ) ? "&Itemid=".$post['Itemid'] : '' );
			$body = str_replace( '[USER]',        $params->get( 'name', $user->get('name') ), $body );
			$body = str_replace( '[FIRST_NAME]',  $params->get( 'name', $user->get('name') ), $body );
			$body = str_replace( '[SUBSCR_NAME]', $post['order_title'],                       $body );
			$body = str_replace( '[SITE_NAME]',   $config->getValue('config.sitename'),       $body );
			$body = str_replace( '[ORDER_ID]',    $post['gateway_id'],                        $body );
			$body = str_replace( '[INVOICE_URL]', $invoice_url,                               $body );

			$subject = $params->get( 'paycheque_cus_subj', $default->get( 'paycheque_cus_subj' ) );
			$mail_result = JUtility::sendMail( $mailfrom, $fromname, array( $params->get( 'userEmail', $user->get('email' ) ) ), JMailHelper::cleanSubject( $subject ),
			JMailHelper::cleanBody( $body ) );

			if( !$mail_result ) {
				JError::raiseWarning( 200, 'Error to send user alert' );
			}
		}

		/*$mail = JFactory::getMailer();

		$sender[0] = $config->getValue( 'config.mailfrom' );
		$sender[1] = $config->getValue( 'config.fromname' );

		$mail->setSender($sender);
		$mail->AddAddress( $params->get( 'userEmail', $user->get('email' ) ) );
		$mail->setBody(JMailHelper::cleanBody($body));
		$mail->setSubject(JMailHelper::cleanSubject($subject));
		if( !$mail->Send() ) {
		JError::raiseWarning(200, 'Error to send user alert');
		}*/

		/*$mailfrom = $params->get( 'userEmail', $user->get('email' ) );
		 $fromname = $params->get( 'name', $user->get('name') );*/
		$bemail = $params->get( 'userEmail', $user->get('email' ) );
		$bname = $params->get( 'name', $user->get('name') );

		if($out['pay'] == 'success')
		$body    = JText::sprintf( "User %s (%s) made successful offline cheque payment on site %s", $bname, $bemail, JURI::root() );
		else
		$body    = JText::sprintf( "User %s (%s) requests offline cheque payment on site %s", $bname, $bemail, JURI::root() );

		$subject = $params->get( 'paycheque_subject', $default->get( 'paycheque_subject' ) );

		$emails = $params->get( 'paycheque_email', $default->get( 'paycheque_email' ) );

		$addresses = array();

		$emails = explode( "\n", str_replace( "\r", "", $emails ) );
		foreach( $emails as $email ) {
			if( !$email ) continue;
			$addresses[] = trim( $email );
		}

		if( count( $addresses ) ) {
			$mail_result = JUtility::sendMail( $mailfrom,
			$fromname,
			$addresses,
			JMailHelper::cleanSubject( $subject ),
			JMailHelper::cleanBody( $body ) );

			if( !$mail_result ) {
				JError::raiseWarning( 200, 'Error to send admin alert' );
			}
		}

		/*$subject = $params->get( 'paycheque_subject', $default->get( 'paycheque_subject' ) );
		 $sender[0] = $params->get( 'userEmail', $user->get('email' ) );
		 $sender[1] = $params->get( 'name', $user->get('name') );
		 $body = "User {$sender[1]} ({$sender[0]}) request cheque paiment";

		 $mail = JFactory::getMailer();
		 $mail->setSender( $sender );

		 $emails = $params->get( 'paycheque_email', $default->get( 'paycheque_email', $config->getValue( 'config.mailfrom' ) ) );

		 $emails = explode( "\n", $emails );
		 foreach( $emails as $email ) {
		 if( !$email ) continue;
		 $mail->AddAddress( trim( $email ) );
		 }

		 $mail->setBody( JMailHelper::cleanBody( $body ) );
		 $mail->setSubject( JMailHelper::cleanSubject( $subject ) );
		 if( !$mail->Send() ) {
		 JError::raiseWarning(200, 'Error to send admin alert');
		 }*/
		return $out;
	}

	function onSendPayment( &$post )
	{
		global $mainframe;
		if( $mainframe->isAdmin() ) return;

		if( $post['processor'] != 'paycheque' ) return false;

		$param['processor']    = $post['processor'];
		$param['option']       = JRequest::getCmd('option');
		$param['email']        = $post['email'];
		$param['task']         = $post['task'];
		$param['view']         = $post['view'];
		$param['layout']       = $post['layout'];
		$param['pay']          = 'offline';
		$param['gateway']      = $post['processor'];
		$param['gateway_id']   = time();
		$param['order_amount'] = $post['order_amount'];
		$param['order_title']  = $post['order_title'];
		$param['order_id']     = $post['order_id'];
		$param['user_id']      = $post['user_id'];
		$param['bill']         = $post['bill_id'];
		if( isset( $post['Itemid'] ) ) {
			$param['Itemid']       = $post['Itemid'];
		}


		if( !isset( $param['order_amount'] ) || !$param['email'] || !$param['processor'] || !$param['order_id'] ) {
			$mainframe->enqueueMessage( 'Some of the required information is missed for completing transaction<br>' );
			return;
		}

		$url = 'index.php?'.$this->jcsArray2Url( $param );
		$mainframe->redirect( $url );
	}

	function onCheckParams($params)
	{
		$db = JFactory::getDBO();
		$sql = "SELECT name FROM #__plugins WHERE folder = 'bill_gateways' AND element = 'paycheque'";
		$db->setQuery($sql);
		$title = $db->loadResult();
		if($params->get('paycheque_cus_body') == '')
		JError::raiseNotice(100, $title.': '.JText::_('Customer Email Alert is not set'));
	}

	function jcsArray2Url( $post )
	{
		foreach( $post AS $k => $v ) {
			$out[] = "$k=$v";
		}
		return implode( '&', $out );
	}
}
?>